Index: trunk/images/presets/misc/cemetery_sector.svg
===================================================================
--- trunk/images/presets/misc/cemetery_sector.svg	(revision 15169)
+++ trunk/images/presets/misc/cemetery_sector.svg	(revision 15169)
@@ -0,0 +1,180 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="13"
+   height="15"
+   viewBox="0 0 13 15"
+   id="svg2"
+   version="1.1"
+   inkscape:version="0.92.3 (2405546, 2018-03-11)"
+   sodipodi:docname="cemetery_sector6.svg">
+  <defs
+     id="defs4" />
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="45.254834"
+     inkscape:cx="0.51125281"
+     inkscape:cy="7.2287704"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     showgrid="true"
+     fit-margin-top="0"
+     fit-margin-left="0"
+     fit-margin-right="0"
+     fit-margin-bottom="0"
+     units="px"
+     inkscape:window-width="1680"
+     inkscape:window-height="987"
+     inkscape:window-x="-8"
+     inkscape:window-y="-8"
+     inkscape:window-maximized="1">
+    <inkscape:grid
+       type="xygrid"
+       id="grid4138"
+       originx="-2"
+       originy="0" />
+  </sodipodi:namedview>
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <dc:title></dc:title>
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1"
+     transform="translate(-2,-1037)">
+    <rect
+       y="1037"
+       x="2"
+       height="8"
+       width="7"
+       id="rect821"
+       style="fill:#333333;fill-opacity:1;stroke:none;stroke-width:1.06904233;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1" />
+    <rect
+       style="fill:#8dd35f;fill-opacity:1;stroke:none;stroke-width:1.09544146;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1"
+       id="rect850"
+       width="5"
+       height="6"
+       x="3"
+       y="1038" />
+    <rect
+       style="fill:#000000;fill-opacity:1;stroke:none;stroke-width:1.15469563;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1"
+       id="rect879"
+       width="1"
+       height="4"
+       x="5"
+       y="1039" />
+    <rect
+       style="fill:#000000;fill-opacity:1;stroke:none;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1"
+       id="rect881"
+       width="3"
+       height="1"
+       x="4"
+       y="1040" />
+    <rect
+       y="1037"
+       x="8"
+       height="8"
+       width="7"
+       id="rect821-3"
+       style="fill:#333333;fill-opacity:1;stroke:none;stroke-width:1.06904233;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1" />
+    <rect
+       style="fill:#8dd35f;fill-opacity:1;stroke:none;stroke-width:1.09544146;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1"
+       id="rect850-1"
+       width="5"
+       height="6"
+       x="9"
+       y="1038" />
+    <rect
+       style="fill:#000000;fill-opacity:1;stroke:none;stroke-width:1.15469563;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1"
+       id="rect879-4"
+       width="1"
+       height="4"
+       x="11"
+       y="1039" />
+    <rect
+       style="fill:#000000;fill-opacity:1;stroke:none;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1"
+       id="rect881-3"
+       width="3"
+       height="1"
+       x="10"
+       y="1040" />
+    <rect
+       y="1044"
+       x="2"
+       height="8"
+       width="7"
+       id="rect821-35"
+       style="fill:#333333;fill-opacity:1;stroke:none;stroke-width:1.06904233;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1" />
+    <rect
+       style="fill:#8dd35f;fill-opacity:1;stroke:none;stroke-width:1.09544146;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1"
+       id="rect850-19"
+       width="5"
+       height="6"
+       x="3"
+       y="1045" />
+    <rect
+       style="fill:#000000;fill-opacity:1;stroke:none;stroke-width:1.15469563;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1"
+       id="rect879-0"
+       width="1"
+       height="4"
+       x="5"
+       y="1046" />
+    <rect
+       style="fill:#000000;fill-opacity:1;stroke:none;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1"
+       id="rect881-1"
+       width="3"
+       height="1"
+       x="4"
+       y="1047" />
+    <rect
+       y="1044"
+       x="8"
+       height="8"
+       width="7"
+       id="rect821-1"
+       style="fill:#333333;fill-opacity:1;stroke:none;stroke-width:1.06904233;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1" />
+    <rect
+       style="fill:#8dd35f;fill-opacity:1;stroke:none;stroke-width:1.09544146;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1"
+       id="rect850-5"
+       width="5"
+       height="6"
+       x="9"
+       y="1045" />
+    <rect
+       style="fill:#000000;fill-opacity:1;stroke:none;stroke-width:1.15469563;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1"
+       id="rect879-3"
+       width="1"
+       height="4"
+       x="11"
+       y="1046" />
+    <rect
+       style="fill:#000000;fill-opacity:1;stroke:none;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1"
+       id="rect881-9"
+       width="3"
+       height="1"
+       x="10"
+       y="1047" />
+  </g>
+</svg>